.TH STARPAC 3F "June 1998"
.SH NAME
STARPAC \- Standards Time Series and Regression Package
.SH SYNOPSIS
.br
\fB/usr/local/lib64/libstarpac.a\fP 
.br
\fB/usr/local/lib64/libdstarpac.a\fP 
.LP
\fB/usr/local/lib64/libstarpac_i8r8d16.a
.br
\fB/usr/local/lib64/libdstarpac_i8r8d16.a
.LP
\fB/usr/local/lib64/libstarpac_f90.a
.br
\fB/usr/local/lib64/libdstarpac_f90.a
.LP
\fB/usr/local/lib64/libstarpac_f90_default64.a
.br
\fB/usr/local/lib64/libdstarpac_f90_default64.a
.LP
\fB/usr/local/lib32/libstarpac.a\fP 
.br
\fB/usr/local/lib32/libdstarpac.a\fP 
.LP
\fB/usr/local/lib32/libstarpac_f90.a
.br
\fB/usr/local/lib32/libdstarpac_f90.a
.SH DESCRIPTION
.LP
STARPAC is a portable library of approximately 150 user-callable ANSI 77
Fortran subroutines for statistical data analysis.  Designed primarily for
time series analysis and for nonlinear least squares regression, STARPAC also
includes subroutines for normal random number generation, line printer plots,
basic statistical analyses and linear least squares. Emphasis has been placed
on facilitating the interpretation of statistical analyses, and, for this
reason, comprehensive printed reports of auxiliary statistical information,
often in graphical form, are automatically provided to augment the basic
statistical computations performed by each user-callable STARPAC subroutine.
STARPAC thus provides the best features of many stand-alone statistical
software programs within the flexible environment of a subroutine library.
.LP
STARPAC is designed to be easy to use; in many situations, only a few
lines of elementary Fortran code are required for the users' main programs. A
fundamental STARPAC philosophy is to provide two or more user-callable
subroutines for each method of analysis:  one which minimizes the complexity
of the CALL statement, automatically producing a comprehensive printed report
of the results; and one or more others which provide user control of the
computations, allow suppression of all or part of the printed reports, and/or
provide storage of computed results for further analyses.
.LP
STARPAC includes routines for
 * line printer graphics
 * normal random number generation
 * histograms
 * statistical analysis of a univariate sample
 * one-way analysis of variance
 * correlation analysis
 * linear least squares
 * nonlinear least squares
 * digital filtering
 * complex demodulation
 * correlation and spectrum analysis
 * arima modeling
.LP
Complete documentation on the STARPAC routines can be found in the directory
/usr/local/apps/starpac/doc in the ASCII file guide.doc.
.LP
For IRIX 6 systems twelve implementations are currently supported, 
.LP
.ta 3i
-lstarpac	f77 -64
.br
-lstarpac_i8r8d16	f77 -64 -i8 -r8 -d16
.br
-lstarpac_f90	f90 -64
.br
-lstarpac_f90_default64	f90 -default64
.LP
-ldstarpac	f77 -64
.br
-ldstarpac_i8r8d16	f77 -64 -i8 -r8 -d16
.br
-ldstarpac_f90	f90 -64
.br
-ldstarpac_f90_default64	f90 -default64
.LP
-lstarpac	f77 -n32
.br
-lstarpac_f90	f90 -n32
.LP
-ldstarpac	f77 -n32
.br
-ldstarpac_f90	f90 -n32
.LP
Libraries labelled "starpac" are coded in single precision whereas
those labelled dstarpac are in double precision.  (Note that the
libraries using auto-doubling options -i8 -r8 -d16 or -default
convert starpac to double precision and dstarpac to quadruple
precision.)
.LP
In order to correctly link to STARPAC, user code must be compiled
with the compiler and options indicated in the second column of
the table above.  For example, each of the following is legal.
.sp
.br
f77 -64 prog.f -lstarpac
.br
f77 -64 prog.f -ldstarpac
.br
f77 -64 -i8 -r8 -d16 prog.f -lstarpac_i8r8d16
.br
f77 -64 -i8 -r8 -d16 prog.f -ldstarpac_i8r8d16
.br
f90 -64 prog.f -lstarpac_f90
.br
f90 -64 prog.f -ldstarpac_f90
.br
f90 -default64 prog.f -lstarpac_f90_default64
.br
f90 -default64 prog.f -ldstarpac_f90_default64
.br
f77 -n32 prog.f -lstarpac
.br
f77 -n32 prog.f -ldstarpac
.br
f90 -n32 prog.f -lstarpac_f90
.br
f90 -n32 prog.f -ldstarpac_f90
.SH FILES
.ta 3i
In \fB/usr/local/lib64 ...
.br
\fBlibstarpac.a\fP			IRIX 6 R10xxx library
.br
\fBlibdstarpac.a\fP			IRIX 6 R10xxx library
.br
\fBlibstarpac_i8r8d16.a\fP		IRIX 6 R10xxx library
.br
\fBlibdstarpac_i8r8d16.a\fP		IRIX 6 R10xxx library
.br
\fBlibstarpac_f90.a\fP			IRIX 6 R10xxx library
.br
\fBlibdstarpac_f90.a\fP			IRIX 6 R10xxx library
.br
\fBlibstarpac_f90_default64.a\fP	IRIX 6 R10xxx library
.br
\fBlibdstarpac_f90_default64.a\fP	IRIX 6 R10xxx library
.sp
In \fB/usr/local/lib32 ...
.br
\fBlibstarpac.a\fP			IRIX 6 R10xxx library
.br
\fBlibdstarpac.a\fP			IRIX 6 R10xxx library
.br
\fBlibstarpac_f90.a\fP			IRIX 6 R10xxx library
.br
\fBlibdstarpac_f90.a\fP			IRIX 6 R10xxx library
.sp
\fB/usr/local/apps/starpac/doc\fP		documentation directory
.br
\fB/usr/local/apps/starpac/src\fP		source directory

.SH SEE\ ALSO
\fBf77\fP(1), \fBf90\fP(1)
