*ADJLMT
      SUBROUTINE ADJLMT(YMN, YMX)
C
C     LATEST REVISION  -  03/15/90  (JRD)
C
C     THIS ROUTINE CORRECTS THE PLOT LIMITS WHEN ALL
C     OBSERVATIONS ARE IDENTICALLY EQUAL.
C
C     WRITTEN BY - JANET R. DONALDSON
C                  STATISTICAL ENGINEERING DIVISION
C                  NATIONAL BUREAU OF STANDARDS, BOULDER, COLORADO
C
C     CREATION DATE  -  JANUARY 21, 1982
C
C
C  VARIABLE DECLARATIONS
C
C  SCALAR ARGUMENTS
      DOUBLE PRECISION
     +   YMN,YMX
C
C  INTRINSIC FUNCTIONS
      INTRINSIC ABS
C
C     VARIABLE DEFINITIONS (ALPHABETICALLY)
C
C     DOUBLE PRECISION YMN, YMX
C        THE Y-AXIS LOWER AND UPPER LIMITS ACTUALLY USED.
C
      IF (YMN .LT. YMX) RETURN
C
C     CORRECT FOR ALL OBSERVATIONS IDENTICALLY EQUAL
C
      YMN = YMN - ABS(YMN/2.0D0)
      YMX = YMX + ABS(YMX/2.0D0)
      IF (YMN .LT. YMX) RETURN
      YMN = -0.5D0
      YMX = 0.5D0
C
      RETURN
      END
