*FITSXP
      SUBROUTINE FITSXP(PAR, PV, SDPV, RES, SDRES, VCV, N, NPAR, IVCV,
     +    RSD)
C
C     LATEST REVISION  -  03/15/90  (JRD)
C
C     GENERATES REPORTS FOR LEAST SQUARES EXERCISER RETURNED STORAGE
C
C     WRITTEN BY  -  LINDA L. MITCHELL
C                    STATISTICAL ENGINEERING DIVISION
C                    NATIONAL BUREAU OF STANDARDS, BOULDER, COLORADO
C
C     CREATION DATE  -  DECEMBER 29, 1982
C
C
C  VARIABLE DECLARATIONS
C
C  SCALAR ARGUMENTS
      DOUBLE PRECISION
     +   RSD
      INTEGER
     +   IVCV,N,NPAR
C
C  ARRAY ARGUMENTS
      DOUBLE PRECISION
     +   PAR(NPAR),PV(N),RES(N),SDPV(N),SDRES(N),VCV(IVCV,NPAR)
C
C  LOCAL SCALARS
      INTEGER
     +   I,IPRT
C
C  EXTERNAL SUBROUTINES
      EXTERNAL IPRINT,LSTVEC,MATPRT
C
C     VARIABLE DEFINITIONS (ALPHABETICALLY)
C
C     INTEGER I
C        INDEX VARIABLE
C     INTEGER IPRT
C        LOGICAL OUTPUT UNIT
C     INTEGER IVCV
C        ACTUAL FIRST DIMENSION OF VCV
C     INTEGER N
C        NUMBER OF OBSERVATIONS
C     INTEGER NPAR
C        NUMBER OF PARAMETERS
C     DOUBLE PRECISION PAR(NPAR)
C        THE ESTIMATED PARAMETERS.
C     DOUBLE PRECISION PV(N)
C        PREDICTED VALUES
C     DOUBLE PRECISION RES(N)
C        RESIDUALS
C     DOUBLE PRECISION RSD
C        RESIDUAL STANDARD DEVIATION
C     DOUBLE PRECISION SDPV(N)
C        STANDARD DEVIATION OF PREDICTED VALUES
C     DOUBLE PRECISION SDRES(N)
C        STANDARD DEVIATION OF RESIDUALS
C     DOUBLE PRECISION VCV(IVCV,NPAR)
C        VARIANCE COVARANCE MATRIX
C
      CALL IPRINT(IPRT)
      WRITE (IPRT,1000)
      WRITE (IPRT,1002)
      CALL LSTVEC(NPAR, PAR)
      WRITE (IPRT,1001)
      DO 10 I=1,N
         WRITE (IPRT,1010) PV(I), SDPV(I), RES(I), SDRES(I)
   10 CONTINUE
      WRITE (IPRT,1020)
      CALL MATPRT(VCV, VCV, NPAR, IPRT, 1, 1, IVCV)
      WRITE (IPRT,1030) RSD
C
      RETURN
C
C     FORMAT STATEMENTS
C
 1000 FORMAT(//40H RETURNED RESULTS FROM LEAST SQUARES FIT/ 1X, 39('-'))
 1001 FORMAT (//7X, 2HPV, 13X, 4HSDPV, 12X, 3HRES,12X, 5HSDRES)
 1002 FORMAT (//20H PARAMETERS FROM FIT)
 1010 FORMAT (1X, G14.7, 2X, G14.7, 2X, G14.7, 2X, G14.7)
 1020 FORMAT (//27H VARIANCE COVARIANCE MATRIX)
 1030 FORMAT (//6H RSD =, G14.7)
      END
