*GENR
      SUBROUTINE GENR(RVECT, N, RINIT, RSTP)
C
C     LATEST REVISION  -  03/15/90  (JRD)
C
C     PUT VALUES RINIT STEP RSTP THROUGH RINIT + (N - 1)*RSTP INTO
C     A VECTOR RVECT OF LENGTH N.  NO ERROR CHECKING IS DONE.
C
C     WRITTEN BY - JOHN E. KOONTZ
C                  STATISTICAL ENGINEERING LAB/BOULDER
C                  NATIONAL BUREAU OF STANDARDS
C
C     CREATION DATE  -  MAY 17, 1982
C
C
C  VARIABLE DECLARATIONS
C
C  SCALAR ARGUMENTS
      DOUBLE PRECISION
     +   RINIT,RSTP
      INTEGER
     +   N
C
C  ARRAY ARGUMENTS
      DOUBLE PRECISION
     +   RVECT(N)
C
C  LOCAL SCALARS
      DOUBLE PRECISION
     +   R
      INTEGER
     +   J
C
C     VARIABLE DEFINITIONS (ALPHABETICALLY)
C
C     INTEGER J
C        LOOP PARAMETER.
C     INTEGER N
C        INPUT PARAMETER.  THE LENGTH OF RVECT.
C     DOUBLE PRECISION R
C        INITIALIZATION VALUE.
C     DOUBLE PRECISION RINIT, RSTP
C        INPUT PARAMETERS.  THE INITIAL VALUE AND THE INCREMENT USED
C        IN CREATING THE INITIALIZATION VALUES.
C     DOUBLE PRECISION RVECT(N)
C        OUTPUT PARAMETER.  THE VECTOR INTO WHICH TO PUT THE VALUES
C        RINIT, RINIT + RSTP, ..., RINIT + (N - 1)*RSTP.
C
      R = RINIT
      DO 10 J=1,N
         RVECT(J) = R
         R = R + RSTP
   10 CONTINUE
      RETURN
      END
