*IPGMN
      SUBROUTINE IPGMN (PER, NF, PERI, ISPCER)
C
C     LATEST REVISION  -  03/15/90  (JRD)
C
C     THIS ROUTINE COMPUTES THE INTEGRATED PERIODOGRAM.
C
C     WRITTEN BY  -  JANET R. DONALDSON
C                    STATISTICAL ENGINEERING DIVISION
C                    NATIONAL BUREAU OF STANDARDS, BOULDER, COLORADO
C
C     CREATION DATE  -  DECEMBER 7, 1981
C
C
C  VARIABLE DECLARATIONS
C
C  SCALAR ARGUMENTS
      INTEGER
     +   ISPCER,NF
C
C  ARRAY ARGUMENTS
      DOUBLE PRECISION
     +   PER(NF),PERI(NF)
C
C  LOCAL SCALARS
      DOUBLE PRECISION
     +   SM
      INTEGER
     +   I
C
C     VARIABLE DEFINITIONS (ALPHABETICALLY)
C
C     INTEGER I
C        AN INDEX VARIABLE
C     INTEGER ISPCER
C        AN ERROR INDICATOR FOR THE INTEGRATED PERIODOGRAM COMPUTATIONS.
C     INTEGER NF
C        THE NUMBER OF FREQUENCIES AT WHICH THE PERIODGRAM IS
C        COMPUTED.
C     DOUBLE PRECISION PER(NF)
C        THE RAW PERIODOGRAM.
C     DOUBLE PRECISION PERI(NF)
C        THE ARRAY WHICH CONTAINS THE INTEGRATED PERIODOGRAM.
C     DOUBLE PRECISION SM
C        A VALUE USED TO COMPUTE THE INTEGRATED PERIODOGRAM ESTIMATES.
C
C
      SM = 0.0D0
C
      DO 30 I = 1, NF
         SM = SM + PER(I)
         PERI(I) = SM
   30 CONTINUE
C
      ISPCER = 1
      IF (SM .EQ. 0.0D0) RETURN
C
      ISPCER = 0
C
      DO 40 I = 1, NF
         PERI(I) = PERI(I)/SM
   40 CONTINUE
C
      RETURN
      END
