*XXCH1
      SUBROUTINE XXCH1(LDSTAK)
C
C     LATEST REVISION  -  03/15/90  (JRD)
C
C     THIS SUBPROGRAM PROVIDES A SIMPLE TEST OF
C     THE PAGE PLOT AND STATISTICAL ANALYSIS FAMILIES OF ROUTINES.
C
C     DATA SET IS 84 RELATIVE HUMIDITY MEASUREMEMTS FROM PIKES PEAK.
C
C     WRITTEN BY  -  JOHN E. KOONTZ, JANET R. DONALDSON
C                    STATISTICAL ENGINEERING DIVISION
C                    NATIONAL BUREAU OF STANDARDS, BOULDER, COLORADO
C
C     CREATION DATE  -  AUGUST 3, 1987
C
C
C  VARIABLE DECLARATIONS
C
C  SCALAR ARGUMENTS
      INTEGER
     +   LDSTAK
C
C  SCALARS IN COMMON
      INTEGER
     +   IERR
C
C  ARRAYS IN COMMON
      DOUBLE PRECISION DSTAK(12)
C
C  LOCAL SCALARS
      INTEGER
     +   I,IPRT,N
C
C  LOCAL ARRAYS
      DOUBLE PRECISION
     +   X(100),Y(100)
C
C  EXTERNAL SUBROUTINES
      EXTERNAL IPRINT,PP,STAT
C
C  COMMON BLOCKS
      COMMON /CSTAK/DSTAK
      COMMON /ERRCHK/IERR
C
C     VARIABLE DEFINITIONS (ALPHABETICALLY)
C
C     DOUBLE PRECISION DSTAK(12)
C        THE DOUBLE PRECISION VERSION OF THE /CSTAK/ WORK AREA.
C     INTEGER I
C        AN INDEX VARIABLE.
C     INTEGER IERR
C        ERROR FLAG
C     INTEGER IPRT
C        LOGICAL OUTPUT UNIT.
C     INTEGER LDSTAK
C        THE LENGTH OF DSTAK IN COMMON /CSTAK/.
C     INTEGER N
C        THE LENGTH OF THE VECTOR Y.
C     DOUBLE PRECISION X(100)
C        THE ORDER INDICES OF THE DATA.
C     DOUBLE PRECISION Y(100)
C        DATA VECTOR FOR TESTS.
C
C
      DATA N /84/
C
      DATA Y( 1), Y( 2), Y( 3), Y( 4)
     +    / 0.6067D0, 0.6087D0, 0.6086D0, 0.6134D0/
      DATA Y( 5), Y( 6), Y( 7)
     +    / 0.6108D0, 0.6138D0, 0.6125D0/
      DATA Y( 8), Y( 9), Y(10), Y(11)
     +    / 0.6122D0, 0.6110D0, 0.6104D0, 0.7213D0/
      DATA Y(12), Y(13), Y(14)
     +    / 0.7078D0, 0.7021D0, 0.7004D0/
      DATA Y(15), Y(16), Y(17), Y(18)
     +    / 0.6981D0, 0.7242D0, 0.7268D0, 0.7418D0/
      DATA Y(19), Y(20), Y(21)
     +    / 0.7407D0, 0.7199D0, 0.6225D0/
      DATA Y(22), Y(23), Y(24), Y(25)
     +    / 0.6254D0, 0.6252D0, 0.6267D0, 0.6218D0/
      DATA Y(26), Y(27), Y(28)
     +    / 0.6178D0, 0.6216D0, 0.6192D0/
      DATA Y(29), Y(30), Y(31), Y(32)
     +    / 0.6191D0, 0.6250D0, 0.6188D0, 0.6233D0/
      DATA Y(33), Y(34), Y(35)
     +    / 0.6225D0, 0.6204D0, 0.6207D0/
      DATA Y(36), Y(37), Y(38), Y(39)
     +    / 0.6168D0, 0.6141D0, 0.6291D0, 0.6231D0/
      DATA Y(40), Y(41), Y(42)
     +    / 0.6222D0, 0.6252D0, 0.6308D0/
      DATA Y(43), Y(44), Y(45), Y(46)
     +    / 0.6376D0, 0.6330D0, 0.6303D0, 0.6301D0/
      DATA Y(47), Y(48), Y(49)
     +    / 0.6390D0, 0.6423D0, 0.6300D0/
      DATA Y(50), Y(51), Y(52), Y(53)
     +    / 0.6260D0, 0.6292D0, 0.6298D0, 0.6290D0/
      DATA Y(54), Y(55), Y(56)
     +    / 0.6262D0, 0.5952D0, 0.5951D0/
      DATA Y(57), Y(58), Y(59), Y(60)
     +    / 0.6314D0, 0.6440D0, 0.6439D0, 0.6326D0/
      DATA Y(61), Y(62), Y(63)
     +    / 0.6392D0, 0.6417D0, 0.6412D0/
      DATA Y(64), Y(65), Y(66), Y(67)
     +    / 0.6530D0, 0.6411D0, 0.6355D0, 0.6344D0/
      DATA Y(68), Y(69), Y(70)
     +    / 0.6623D0, 0.6276D0, 0.6307D0/
      DATA Y(71), Y(72), Y(73), Y(74)
     +    / 0.6354D0, 0.6197D0, 0.6153D0, 0.6340D0/
      DATA Y(75), Y(76), Y(77)
     +    / 0.6338D0, 0.6284D0, 0.6162D0/
      DATA Y(78), Y(79), Y(80), Y(81)
     +    / 0.6252D0, 0.6349D0, 0.6344D0, 0.6361D0/
      DATA Y(82), Y(83), Y(84)
     +    / 0.6373D0, 0.6337D0, 0.6383D0/
C
C     DEFINE IPRT, THE CURRENT OUTPUT UNIT.
C
      CALL IPRINT(IPRT)
C
      DO 10 I=1,N
         X(I) = I
   10 CONTINUE
C
C     PRINT HEADING
C
      WRITE (IPRT,1000)
C
C     PERFORM SIMPLE TEST OF PP
C
      WRITE (IPRT,1100)
      CALL PP(Y, X, N)
      WRITE (IPRT,2000) IERR
C
C     PERFORM SIMPLE TEST OF STAT
C
      WRITE (IPRT,1200)
      CALL STAT(Y, N, LDSTAK)
      WRITE (IPRT,2000) IERR
C
      RETURN
C
C     FORMATS
C
 1000 FORMAT ('1*CH1')
 1100 FORMAT (' SIMPLE TEST OF PP')
 1200 FORMAT ('1SIMPLE TEST OF STAT')
 2000 FORMAT (/' THE VALUE OF IERR IS ', I4)
      END
