*XXCH5
      SUBROUTINE XXCH5(LDSTAK)
C
C     LATEST REVISION  -  03/15/90  (JRD)
C
C     THIS SUBPROGRAM PROVIDES A SIMPLE TEST OF
C     THE STATISTICAL ANALYSIS FAMILY OF ROUTINES.
C
C     DATA SET IS FROM PAGE 39 OF MANDEL [1964]
C
C     WRITTEN BY  -  JOHN E. KOONTZ, JANET R. DONALDSON
C                    STATISTICAL ENGINEERING DIVISION
C                    NATIONAL BUREAU OF STANDARDS, BOULDER, COLORADO
C
C     CREATION DATE  -  AUGUST 3, 1987
C
C
C  VARIABLE DECLARATIONS
C
C  SCALAR ARGUMENTS
      INTEGER
     +   LDSTAK
C
C  SCALARS IN COMMON
      INTEGER
     +   IERR
C
C  ARRAYS IN COMMON
      DOUBLE PRECISION DSTAK(12)
C
C  LOCAL SCALARS
      INTEGER
     +   IPRT,N
C
C  LOCAL ARRAYS
      DOUBLE PRECISION
     +   Y(40)
C
C  EXTERNAL SUBROUTINES
      EXTERNAL IPRINT,STAT
C
C  COMMON BLOCKS
      COMMON /CSTAK/DSTAK
      COMMON /ERRCHK/IERR
C
C     VARIABLE DEFINITIONS (ALPHABETICALLY)
C
C     DOUBLE PRECISION DSTAK(12)
C        THE DOUBLE PRECISION VERSION OF THE /CSTAK/ WORK AREA.
C     INTEGER IERR
C        ERROR FLAG
C     INTEGER IPRT
C        LOGICAL OUTPUT UNIT.
C     INTEGER LDSTAK
C        THE LENGTH OF DSTAK IN COMMON /CSTAK/.
C     INTEGER N
C        THE LENGTH OF THE VECTOR Y.
C     DOUBLE PRECISION Y(40)
C        DATA VECTOR FOR TESTS.
C
C     DATA INITIALIZATIONS.
C
      DATA N /39/
C
      DATA Y( 1), Y( 2), Y( 3), Y( 4)
     +    / 0.4, 0.6, 1.0, 1.0/
      DATA Y( 5), Y( 6), Y( 7), Y( 8)
     +    / 1.0, 0.5, 0.6, 0.7/
      DATA Y( 9), Y(10), Y(11), Y(12)
     +    / 1.0, 0.6, 0.2, 1.9/
      DATA Y(13), Y(14), Y(15), Y(16)
     +    / 0.2, 0.4, 0.0, -0.4/
      DATA Y(17), Y(18), Y(19), Y(20)
     +    / -0.3, 0.0, -0.4, -0.3/
      DATA Y(21), Y(22), Y(23), Y(24)
     +    / 0.1, -0.1, 0.2, -0.5/
      DATA Y(25), Y(26), Y(27), Y(28)
     +    / 0.3, -0.1, 0.2, -0.2/
      DATA Y(29), Y(30), Y(31), Y(32)
     +    / 0.8, 0.5, 0.6, 0.8/
      DATA Y(33), Y(34), Y(35), Y(36)
     +    / 0.7, 0.7, 0.2, 0.5/
      DATA Y(37), Y(38), Y(39)
     +    / 0.7, 0.8, 1.1/
C
C     DEFINE IPRT, THE CURRENT OUTPUT UNIT.
C
      CALL IPRINT(IPRT)
C
C     PRINT HEADING
C
      WRITE (IPRT,1000)
C
C     PERFORM SIMPLE TEST OF STAT
C
      WRITE (IPRT,1100)
      CALL STAT(Y, N, LDSTAK)
      WRITE (IPRT,2000) IERR
C
      RETURN
C
C     FORMATS
C
 1000 FORMAT ('1*CH5')
 1100 FORMAT (' SIMPLE TEST OF STAT')
 2000 FORMAT (/' THE VALUE OF IERR IS ', I4)
      END
