*XXCH6
      SUBROUTINE XXCH6(LDSTAK)
C
C     LATEST REVISION  -  03/15/90  (JRD)
C
C     THIS SUBPROGRAM PROVIDES A SIMPLE TEST OF
C     THE ONEWAY ANALYSIS OF VARIANCE FAMILY OF ROUTINES.
C
C     DATA SET IS FROM PAGES 314-316 OF BRWONLEE [1965].
C
C     WRITTEN BY  -  JOHN E. KOONTZ, JANET R. DONALDSON
C                    STATISTICAL ENGINEERING DIVISION
C                    NATIONAL BUREAU OF STANDARDS, BOULDER, COLORADO
C
C     CREATION DATE  -  AUGUST 3, 1987
C
C
C  VARIABLE DECLARATIONS
C
C  SCALAR ARGUMENTS
      INTEGER
     +   LDSTAK
C
C  SCALARS IN COMMON
      INTEGER
     +   IERR
C
C  ARRAYS IN COMMON
      DOUBLE PRECISION DSTAK(12)
C
C  LOCAL SCALARS
      INTEGER
     +   IPRT,N
C
C  LOCAL ARRAYS
      DOUBLE PRECISION
     +   TAG(20),Y(20)
C
C  EXTERNAL SUBROUTINES
      EXTERNAL AOV1,IPRINT
C
C  COMMON BLOCKS
      COMMON /CSTAK/DSTAK
      COMMON /ERRCHK/IERR
C
C     VARIABLE DEFINITIONS (ALPHABETICALLY)
C
C     DOUBLE PRECISION DSTAK(12)
C        THE DOUBLE PRECISION VERSION OF THE /CSTAK/ WORK AREA.
C     INTEGER IERR
C        ERROR FLAG
C     INTEGER IPRT
C        LOGICAL OUTPUT UNIT.
C     INTEGER LDSTAK
C        THE LENGTH OF DSTAK IN COMMON /CSTAK/.
C     INTEGER N
C        THE LENGTH OF THE VECTOR Y.
C     DOUBLE PRECISION TAG(20)
C        THE TAG VALUES FOR EACH OBSERVATION
C     DOUBLE PRECISION Y(20)
C        DATA VECTOR FOR TESTS.
C
C
C     DATA INITIALIZATIONS.
C
      DATA N /16/
C
      DATA Y( 1), Y( 2), Y( 3), Y( 4)
     +    / 83.0, 81.0, 76.0, 78.0/
      DATA Y( 5), Y( 6), Y( 7), Y( 8)
     +    / 79.0, 72.0, 61.0, 61.0/
      DATA Y( 9), Y(10), Y(11), Y(12)
     +    / 67.0, 67.0, 64.0, 78.0/
      DATA Y(13), Y(14), Y(15), Y(16)
     +    / 71.0, 75.0, 72.0, 74.0/
C
      DATA TAG( 1), TAG( 2), TAG( 3), TAG( 4)
     +    / 1.0, 1.0, 1.0, 1.0/
      DATA TAG( 5), TAG( 6), TAG( 7), TAG( 8)
     +    / 1.0, 1.0, 2.0, 2.0/
      DATA TAG( 9), TAG(10), TAG(11), TAG(12)
     +    / 2.0, 2.0, 2.0, 3.0/
      DATA TAG(13), TAG(14), TAG(15), TAG(16)
     +    / 3.0, 3.0, 3.0, 3.0/
C
C     DEFINE IPRT, THE CURRENT OUTPUT UNIT.
C
      CALL IPRINT(IPRT)
C
C     PRINT HEADING
C
      WRITE (IPRT,1000)
C
C     PERFORM SIMPLE TEST OF AOV1
C
      WRITE (IPRT,1100)
      CALL AOV1(Y, TAG, N, LDSTAK)
      WRITE (IPRT,2000) IERR
C
      RETURN
C
C     FORMATS
C
 1000 FORMAT ('1*CH6')
 1100 FORMAT (' SIMPLE TEST OF AOV1')
 2000 FORMAT (/' THE VALUE OF IERR IS ', I4)
      END
