*AIMX1
      SUBROUTINE AIMX1(MXN, MXPAR, MXFC, MXFCO, MXFAC,
     +   MOD, N, MSPEC, NFAC, PAR, NPAR, RES,
     +   IFIXED, STP, MIT, STOPSS, STOPP, SCALE, DELTA, IVAPRX, NPRT,
     +   NPARE, RSD, PV, SDPV, SDRES, VCV, IVCV,
     +   NFCST, NFCSTO, IFCSTO, FCST, IFCST, FCSTSD)
C
C     LATEST REVISION  -  03/15/90  (JRD)
C
C     SET THE STARTING PARAMETER VALUES FOR AIMX
C
C     WRITTEN BY  -  JANET R. DONALDSON
C                    STATISTICAL ENGINEERING DIVISION
C                    NATIONAL BUREAU OF STANDARDS, BOULDER, COLORADO
C
C     CREATION DATE  -  DECEMBER 2, 1985
C
C
C  VARIABLE DECLARATIONS
C
C  SCALAR ARGUMENTS
      REAL
     +   DELTA,RSD,STOPP,STOPSS
      INTEGER
     +   IFCST,IVAPRX,IVCV,MIT,MOD,MXFAC,MXFC,MXFCO,MXN,MXPAR,N,
     +   NFAC,NFCST,NFCSTO,NPAR,NPARE,NPRT
C
C  ARRAY ARGUMENTS
      REAL
     +   FCST(MXFC,*),FCSTSD(*),PAR(*),PV(*),RES(*),SCALE(*),SDPV(*),
     +   SDRES(*),STP(*),VCV(MXPAR,*)
      INTEGER
     +   IFCSTO(*),IFIXED(*),MSPEC(4,*)
C
C  SCALARS IN COMMON
      INTEGER
     +   IERR
C
C  LOCAL SCALARS
      REAL
     +   SQMEPS
      INTEGER
     +   I,J
C
C  EXTERNAL FUNCTIONS
      REAL
     +   RMDCON
      EXTERNAL RMDCON
C
C  EXTERNAL SUBROUTINES
      EXTERNAL SETRV
C
C  INTRINSIC FUNCTIONS
      INTRINSIC SQRT
C
C  COMMON BLOCKS
      COMMON /ERRCHK/IERR
C
C     VARIABLE DEFINITIONS (ALPHABETICALLY)
C
C     REAL DELTA
C        THE MAXIMUM CHANGE ALLOWED IN THE MODEL PARAMETERS AT THE
C        FIRST ITERATION.
C     REAL FCST(MXFC,MXFCO)
C        THE FORECASTS.
C     REAL FCSTSD(MXFC)
C        THE STANDARD DEVIATION OF THE FORECASTS.
C     INTEGER I
C        *
C     INTEGER IERR
C        THE INTEGER VALUE RETURNED BY THIS ROUTINE DESIGNATING
C        WHETHER ANY ERRORS WERE DETECTED IN THE PARAMETER LIST.
C        IF IERR .EQ. 0, NO ERRORS WERE DETECTED.
C        IF IERR .GE. 1, ERRORS WERE DETECTED.
C     INTEGER IFCST
C        *
C     INTEGER IFCSTO(MXFCO)
C        THE FORECAST ORIGINS.
C     INTEGER IFIXED(MXPAR)
C        THE INDICATOR VALUES USED TO DESIGNATE WHETHER THE
C        PARAMETERS ARE TO BE OPTIMIZED OR ARE TO BE HELD FIXED.  IF
C        IFIXED(I).NE.0, THEN PAR(I) WILL BE OPTIMIZED.  IF
C        IFIXED(I).EQ.0, THEN PAR(I) WILL BE HELD FIXED.
C        IFIXED(I).LT.0, THEN ALL PAR(I),I=1,NPAR, WILL BE OPTIMIZED..
C     INTEGER IVAPRX
C        *
C     INTEGER IVCV
C        THE ACTUAL FIRST DIMENSION OF VCV.
C     INTEGER J
C        *
C     INTEGER MIT
C        *
C     INTEGER MOD
C        AN INDICATOR VALUE USED TO DESIGNATE THE MODEL FOR WHICH
C        THE PARAMETERS ARE TO BE SET.
C     INTEGER MSPEC(4,MXFAC)
C        THE VALUES OF P, D, Q AND S FOR EACH FACTOR.
C     INTEGER MXFAC
C        THE MAXIMUM NUMBER OF FACTORS ALLOWED.
C     INTEGER MXFC
C        THE MAXIMUM NUMBER OF FORECASTS ALLOWED.
C     INTEGER MXFCO
C        THE MAXIMUM NUMBER OF FORECASTS ORIGINS ALLOWED.
C     INTEGER MXN
C        THE MAXIMUM NUMBER OF OBSERVATIONS ALLOWED.
C     INTEGER MXPAR
C        THE MAXIMUM NUMBER OF PARAMETERS ALLOWED.
C     INTEGER N
C        THE NUMBER OF OBSERVATIONS.
C     INTEGER NFAC
C        THE NUMBER OF FACTORS IN THE MODEL
C     INTEGER NFCST, NFCSTO
C        THE NUMBER OF FORECASTS AND FORCAST ORIGINS.
C     INTEGER NPAR
C        THE NUMBER OF PARAMETERS IN THE MODEL.
C        TO BE PROVIDED.
C     INTEGER NPARE
C        THE NUMBER OF PARAMETERS ESTIMATED BY THE ROUTINE.
C     INTEGER NPRT
C        *
C     REAL PAR(MXPAR)
C        THE ARRAY IN WHICH THE CURRENT ESTIMATES OF THE UNKNOWN
C        PARAMETERS ARE STORED.
C     REAL PV(MXN)
C        THE PREDICTED VALUES.
C     REAL RES(MXN)
C        THE RESIDUALS.
C     REAL RSD
C        THE RESIDUAL STANDARD DEVIATION.
C     REAL SCALE(MXPAR)
C        THE SCALE VALUES.
C     REAL SDPV(MXN)
C        THE STANDARD DEVIATION OF THE PREDICTED VALUES.
C     REAL SDRES(MXN)
C        THE STANDARDIZED RESIDUALS.
C     REAL SQMEPS, STOPP, STOPSS
C        *
C     REAL STP(MXPAR)
C        THE STEP VALUES.
C     REAL VCV(MXPAR,MXPAR)
C        THE VARIANCE COVARIANCE MATRIX.
C
      GO TO (10, 20, 30, 40, 50, 60), MOD
C
   10 CONTINUE
      N = 144
      NFAC = 2
      MSPEC(1,1) = 0
      MSPEC(2,1) = 1
      MSPEC(3,1) = 1
      MSPEC(4,1) = 1
      MSPEC(1,2) = 0
      MSPEC(2,2) = 1
      MSPEC(3,2) = 1
      MSPEC(4,2) = 12
      NPAR = 3
      PAR(1) = 0.0E0
      PAR(2) = 0.4E0
      PAR(3) = 0.6E0
      IFIXED(1) = 1
      IFIXED(2) = 0
      IFIXED(3) = 0
C
      GO TO 70
C
C
   20 PAR(1) = 1.0E0
      PAR(2) = 2.0E0
      PAR(3) = 3.0E0
C
      GO TO 70
C
C
   30 PAR(1) = 6.0E0
      PAR(2) = 5.0E0
      PAR(3) = 4.0E0
      PAR(4) = 3.0E0
      PAR(5) = 2.0E0
C
      GO TO 70
C
C
   40 CALL SETRV(PAR, NPAR, 0.0E0)
C
      GO TO 70
C
C
   50 CALL SETRV(PAR, NPAR, 0.5E0)
C
      GO TO 70
C
C
   60 PAR(1) = 100.0E0
      PAR(2) = 15.0E0
C
   70 CONTINUE
C
      SQMEPS = SQRT(RMDCON(3))
C
      MIT = 25
      DO 80 I=1,10
         STP(I) = SQMEPS
         SCALE(I) = 1.0E0
   80 CONTINUE
      STOPSS = 10.0E-7
      STOPP = 10.0E-7
      DELTA = 0.5E0
      NPRT = 11111
      IVAPRX = 3
      IVCV = MXPAR
C
      NFCST = 36
      NFCSTO = 2
      IFCSTO(1) = 103
      IFCSTO(2) = N
      IFCST = MXFC
C
      DO 85 I=1,MXN
         RES(I) = -1.0E0
         PV(I) = -1.0E0
         SDPV(I) = -1.0E0
         SDRES(I) = -1.0E0
   85 CONTINUE
C
      DO 100 I=1,MXPAR
         DO 90 J=1,MXPAR
            VCV(I,J) = -1.0E0
   90    CONTINUE
  100 CONTINUE
C
      DO 110 I = 1, MXFC
        FCSTSD(I) = -1.0E0
        DO 105 J = 1, MXFCO
          FCST(I,J) = -1.0E0
  105   CONTINUE
  110 CONTINUE
C
      NPARE = -1
      RSD = -1.0E0
C
      IERR = -1
C
      RETURN
C
      END
