*CDFNML
      REAL FUNCTION CDFNML(X)
C
C     LATEST REVISION  -  03/15/90  (JRD)
C
C     THIS ROUTINE COMPUTES THE NORMAL CUMULATIVE DISTRIBUTION
C     FUNCTION FROM THE ERROR FUNCTION AS DESCRIBED IN CHAPTER 13
C     OF DISTRIBUTIONS IN STATISTICS - CONTINUOUS UNIVARIATE
C     DISTRIBUTIONS - 1, BY JOHNSON AND KOTZ.
C
C     WRITTEN BY - JANET R. DONALDSON
C                  STATISTICAL ENGINEERING DIVISION
C                  NATIONAL BUREAU OF STANDARDS, BOULDER, COLORADO
C
C     CREATION DATE - DECEMBER 7, 1981
C
C
C  VARIABLE DECLARATIONS
C
C  SCALAR ARGUMENTS
      REAL
     +   X
C
C  EXTERNAL FUNCTIONS
      REAL
     +    ERF
      EXTERNAL  ERF
C
C  INTRINSIC FUNCTIONS
      INTRINSIC SQRT
C
C     VARIABLE DEFINITIONS (ALPHABETICALLY)
C
C     REAL X
C        THE PERCENT POINT FROM THE CHI SQUARED DISTRIBUTION.
C
C     COMMENCE BODY OF ROUTINE
C
      CDFNML = 0.5E0 * (1.0E0 +  ERF(X/SQRT(2.0E0)))
C
      RETURN
      END
