*CNTR
      SUBROUTINE CNTR (Y, N, YC)
C
C     LATEST REVISION  -  03/15/90  (JRD)
C
C     THIS ROUTINE CENTERS THE INPUT SERIES Y ABOUT ITS MEAN,
C     RETURNING THE CENTERED SERIES IN YC.
C
C     WRITTEN BY - JANET R. DONALDSON
C                  STATISTICAL ENGINEERING DIVISION
C                  NATIONAL BUREAU OF STANDARDS, BOULDER, COLORADO
C
C     CREATION DATE  -  DECEMBER 7, 1981
C
C
C  VARIABLE DECLARATIONS
C
C  SCALAR ARGUMENTS
      INTEGER
     +   N
C
C  ARRAY ARGUMENTS
      REAL
     +   Y(*),YC(*)
C
C  LOCAL SCALARS
      REAL
     +   YMEAN
      INTEGER
     +   I
C
C  EXTERNAL SUBROUTINES
      EXTERNAL AMEAN
C
C     VARIABLE DEFINITIONS (ALPHABETICALLY)
C
C     INTEGER I
C        AN INDEX VARIABLE.
C     INTEGER N
C        THE NUMBER OF OBSERVATIONS IN THE INPUT SERIES.
C     REAL Y(N)
C        THE INPUT ARRAY OF OBSERVATIONS TO BE CENTERED.
C     REAL YC(N)
C        THE OUTPUT ARRAY OF CENTERED OBSERVATIONS.
C     REAL YMEAN
C        THE MEAN OF THE INPUT SERIES.
C
      CALL AMEAN (Y, N, YMEAN)
C
      DO 10 I = 1, N
         YC(I) = Y(I) - YMEAN
   10 CONTINUE
C
      RETURN
C
      END
