*EXTEND
      REAL FUNCTION EXTEND(X, I, N, SYM)
C
C     LATEST REVISION  -  03/15/90  (JRD)
C
C      THIS FUNCTION RETURNS THE ITH TERM IN THE SERIES X,
C     EXTENDING IF NECESSARY WITH EVEN OR ODD SYMMETRY ACCORDING
C     TO THE SIGN OF SYM, WHICH SHOULD BE EITHER PLUS OR MINUS ONE.
C     (THE VALUE ZERO WILL RESULT IN THE EXTENDED VALUE BEING ZERO.)
C     THIS ROUTINE IS TAKEN FROM BLOOMFIELDS BOOK, PAGE 179.
C
C     WRITTEN BY  -  PETER BLOOMFIELD
C     CODED BY  -  JANET R. DONALDSON
C                  STATISTICAL ENGINEERING DIVISION
C                  NATIONAL BUREAU OF STANDARDS, BOULDER, COLORADO
C
C     CREATION DATE  -  DECEMBER 7, 1981
C
C
C  VARIABLE DECLARATIONS
C
C  SCALAR ARGUMENTS
      REAL
     +   SYM
      INTEGER
     +   I,N
C
C  ARRAY ARGUMENTS
      REAL
     +   X(N)
C
C  LOCAL SCALARS
      REAL
     +   CON
      INTEGER
     +   J
C
      J = I
      CON = 1.0E0
   10 IF (J .GE. 1) GO TO 20
      J = 2-J
      CON = CON * SYM
   20 IF (J .LE. N) GO TO 30
      J = 2*N-J
      CON = CON * SYM
      GO TO 10
   30 EXTEND = X(J)*CON
C
      RETURN
C
      END
