*MVCHK
      LOGICAL FUNCTION MVCHK (X, XMISS)
C
C     LATEST REVISION  -  03/15/90  (JRD)
C
C     THIS ROUTINE CHECKS WHETHER X = XMISS (MVCHK = TRUE) OR NOT
C     (MVCHK = FALSE) IN A MANNER WHICH WILL PREVENT VERY LARGE OR
C     VERY SMALL MISSING VALUE CODES FROM CAUSING AN OVERFLOW.
C
C     WRITTEN BY - JANET R. DONALDSON
C                  STATISTICAL ENGINEERING DIVISION
C                  NATIONAL BUREAU OF STANDARDS, BOULDER, COLORADO
C
C     CREATION DATE  -  DECEMBER 7, 1981
C
C
C  VARIABLE DECLARATIONS
C
C  SCALAR ARGUMENTS
      REAL
     +   X,XMISS
C
C  INTRINSIC FUNCTIONS
      INTRINSIC ABS
C
C     VARIABLE DEFINITIONS (ALPHABETICALLY)
C
C     REAL X
C        THE VALUE TO BE CHECKED.
C     REAL XMISS
C        THE USER SUPPLIED CODE WHICH IS USED TO DETERMINE WHETHER OR
C        NOT AN OBSERVATION IS MISSING.  IF X = XMISS,
C        THE VALUE IS ASSUMED MISSING, OTHERWISE IT IS NOT.
C
      IF ((X .GT. 0.0E0 .AND. XMISS .LT. 0.0E0) .OR.
     +    (X .LT. 0.0E0 .AND. XMISS .GT. 0.0E0)) GO TO 10
C
      IF (ABS(X) .EQ. ABS(XMISS)) GO TO 20
C
   10 MVCHK = .FALSE.
      RETURN
C
   20 MVCHK = .TRUE.
      RETURN
C
      END
