*SPPLTC
      SUBROUTINE SPPLTC (XAXIS, YAXIS, ISYM, NPTS, XPLTMN, XPLTMX, BW,
     +   CILOW, CIMID, CIUP, LPCV)
C
C     LATEST REVISION  -  03/15/90  (JRD)
C
C     THIS ROUTINE PRODUCES CONFIDENCE INTERVAL AND BANDWIDTH
C     CO-ORDINATES FOR THE SPECTRUM PLOTS.
C
C     WRITTEN BY - JANET R. DONALDSON
C                  STATISTICAL ENGINEERING DIVISION
C                  NATIONAL BUREAU OF STANDARDS, BOULDER, COLORADO
C
C     CREATION DATE  -  DECEMBER 7, 1981
C
C
C  VARIABLE DECLARATIONS
C
C  SCALAR ARGUMENTS
      REAL
     +   BW,CILOW,CIMID,CIUP,XPLTMN,XPLTMX
      INTEGER
     +   LPCV,NPTS
C
C  ARRAY ARGUMENTS
      REAL
     +   XAXIS(LPCV),YAXIS(LPCV)
      INTEGER
     +   ISYM(LPCV)
C
C  INTRINSIC FUNCTIONS
      INTRINSIC MAX
C
C     VARIABLE DEFINITIONS (ALPHABETICALLY)
C
C     REAL BW
C       THE BANDWIDTH.
C     REAL CILOW, CIMID, CIUP
C        THE Y CORDNATES FOR THE LOWER  MID AND UPPER CONFIDENCE
C        INTERVAL POINTS.
C     INTEGER ISYM(LPCV)
C        THE ARRAY CONTAINING THE CODE FOR THE PLOT SYMBOLS.
C     INTEGER LPCV
C        THE LENGTH OF THE VECTORS USED FOR THE PLOTS.
C     INTEGER NPTS
C        THE NUMBER OF CO-ORDINATES TO BE PLOTTED.
C     REAL XAXIS(LPCV)
C        THE X AXIS VALUES FOR THE SPECTRUM PLOT.
C     REAL XPLTMN, XPLTMX
C        THE MINIMUM AND MAXIMUM VALUES TO BE PLOTTED FOR THE X AXIS.
C     REAL YAXIS(LPCV)
C        THE Y AXIS VALUES FOR THE SPECTRUM PLOTS.
C
      IF (XPLTMX - XPLTMN .GE. BW) GO TO 10
C
      XPLTMX = MAX(XPLTMX + (BW - XPLTMX + XPLTMN) / 2.0E0, 0.5E0)
      XPLTMN = XPLTMX - BW
C
   10 CONTINUE
C
      NPTS = NPTS + 1
C
      XAXIS(NPTS) = XPLTMX - 0.5E0 * BW
      YAXIS(NPTS) = CIUP
      ISYM(NPTS) = 7
C
      NPTS = NPTS + 1
C
      XAXIS(NPTS) = XPLTMX - 0.5E0 * BW
      YAXIS(NPTS) = CIMID
      ISYM(NPTS) = 3
C
      NPTS = NPTS + 1
C
      XAXIS(NPTS) = XPLTMX - 0.5E0 * BW
      YAXIS(NPTS) = CILOW
      ISYM(NPTS) = 13
C
      NPTS = NPTS + 1
C
      XAXIS(NPTS) = XPLTMX - BW
      YAXIS(NPTS)  = CIMID
      ISYM(NPTS) = 6
C
      NPTS = NPTS + 1
C
      XAXIS(NPTS) = XPLTMX
      YAXIS(NPTS)  = CIMID
      ISYM(NPTS) = 27
C
      RETURN
      END
