*UASCFT
      SUBROUTINE UASCFT (ACOV, LAGMAX, LACOV, IAR, PHI, N, VAR)
C
C     LATEST REVISION  -  03/15/90  (JRD)
C
C     THIS ROUTINE COMPUTES THE AUTOREGRESSIVE MODEL COEFFICIENTS
C     FOR AN ORDER IAR MODEL USING DURBINS RECURSIVE METHOD.
C
C     WRITTEN BY  -  JANET R. DONALDSON
C                    STATISTICAL ENGINEERING DIVISION
C                    NATIONAL BUREAU OF STANDARDS, BOULDER, COLORADO
C
C     CREATION DATE  -  DECEMBER 7, 1981
C
C
C  VARIABLE DECLARATIONS
C
C  SCALAR ARGUMENTS
      REAL
     +   VAR
      INTEGER
     +   IAR,LACOV,LAGMAX,N
C
C  ARRAY ARGUMENTS
      REAL
     +   ACOV(LACOV),PHI(IAR)
C
C  LOCAL SCALARS
      REAL
     +   RSS
      INTEGER
     +   L
C
C  EXTERNAL SUBROUTINES
      EXTERNAL ARCOEF
C
C     VARIABLE DEFINITIONS (ALPHABETICALLY)
C
C     REAL ACOV(LACOV)
C        THE ARRAY OF AUTOCOVARIANCE ESTIMATES.
C     INTEGER IAR
C        THE ORDER OF THE AUTOREGRESSIVE PROCESS CHOSEN.
C     INTEGER L
C        AN INDEX VARIABLE.
C     INTEGER LACOV
C        THE LENGTH OF THE ARRAY ACOV.
C     INTEGER LAGMAX
C        THE MAXIMUM LAG VALUE TO BE USED.
C     INTEGER N
C        THE NUMBER OF OBSERVATIONS IN THE SERIES.
C     REAL PHI(IAR)
C        THE ARRAY OF AUTOREGRESSIVE COEFFICIENTS FOR THE
C        SELECTED ORDER.
C     REAL RSS, VAR
C
C
      PHI(1) = ACOV(2) / ACOV(1)
      RSS = ACOV(1) * N * (1.0E0 - PHI(1)*PHI(1))
C
      IF (IAR .LE. 1) GO TO 20
C
      DO 10 L = 2, IAR
         CALL ARCOEF(ACOV(2), PHI, RSS, L, LAGMAX, ACOV(1))
   10 CONTINUE
C
   20 VAR = RSS / (N-IAR-1)
C
      RETURN
C
      END
