*XBFS
      SUBROUTINE XBFS(LDS)
C
C     LATEST REVISION  -  03/15/90  (JRD)
C
C     ROUTINE TO TEST THE FOURIER SPECTRUM ANALYSIS ROUTINES
C
C     SERIES Y1 AND Y2 ARE LISTED AS SERIES X1 AND X2 ON PAGE OF 361 OF
C     JENKINS AND WATTS.
C
C     WRITTEN BY - JANET R. DONALDSON
C                  STATISTICAL ENGINEERING DIVISION
C                  NATIONAL BUREAU OF STANDARDS, BOULDER, COLORADO
C
C     CREATION DATE  -  DECEMBER 2, 1985
C
C
C  VARIABLE DECLARATIONS
C
C  SCALAR ARGUMENTS
      INTEGER
     +   LDS
C
C  SCALARS IN COMMON
      INTEGER
     +   IERR
C
C  ARRAYS IN COMMON
      DOUBLE PRECISION DSTAK(12)
C
C  LOCAL SCALARS
      REAL
     +   CMISS,FMAX,FMIN,YMISS,YMISS1,YMISS2
      INTEGER
     +   I,ICCOV,ICSPC2,INDEX1,INDEX2,INLPPC,IPHAS,IPRT,ISPCF,J,
     +   JCCOV,JNLPPC,LACOV,LAGMAX,LDSTAK,LYFFT,N,NF,NPRT,NW
C
C  LOCAL ARRAYS
      REAL
     +   CCOV(101,2,2),CSPC2(300,2),FREQ(300),PHAS(300,2),Y1(150),
     +   Y2(150),YFFT1(400),YFFT2(400),YM(150,2),YMMISS(4)
      INTEGER
     +   LAGS(4),NLPPC(101,2,2)
C
C  EXTERNAL SUBROUTINES
      EXTERNAL BFS,BFSF,BFSFS,BFSM,BFSMS,BFSMV,BFSMVS,BFSS,BFSV,BFSVS,
     +   CCFMS,CCFS,IPRINT,NRAND,SCOPY,SETIV,SETRV
C
C  COMMON BLOCKS
      COMMON /CSTAK/DSTAK
      COMMON /ERRCHK/IERR
C
C  EQUIVALENCES
      EQUIVALENCE (YM(1,1),Y1(1))
      EQUIVALENCE (YM(1,2),Y2(1))
C
C     VARIABLE DEFINITIONS (ALPHABETICALLY)
C
C     REAL CMISS
C         THE MISSING VALUE CODE FOR THE RETURNED CCVF ESTIMATES.
C     REAL CCOV(101,2,2)
C        THE COVARIANCES.
C     REAL CSPC2(300,2)
C        THE SQUARED COHERENCY COMPONENT OF THE SPECTRUM.
C     DOUBLE PRECISION DSTAK(12)
C        THE DOUBLE PRECISION VERSION OF THE /CSTAK/ WORK AREA.
C     REAL FMAX, FMIN
C        THE MAXIMUM AND MINIMUM FREQUENCIES AT WHICH THE
C        SPECTRUM IS TO BE COMPUTED.
C     REAL FREQ(300)
C        THE VECTOR OF FREQUENCIES AT WHICH THE SPECTRUM IS COMPUTED.
C     INTEGER I
C        AN INDEX VARIABLE
C     INTEGER ICCOV
C        THE FIRST DIMENSION OF THE ARRAY CCOV.
C     INTEGER ICSPC2
C        THE FIRST DIMENSION OF THE ARRAY CSPC2.
C     INTEGER IERR
C        THE INTEGER VALUE RETURNED BY THIS ROUTINE DESIGNATING
C        WHETHER ANY ERRORS WERE DETECTED IN THE PARAMETER LIST
C        IF IERR .EQ. 0, NO ERRORS WERE DETECTED
C        IF IERR .EQ. 1, ERRORS HAVE BEEN DETECTED
C     INTEGER IPHAS
C        THE FIRST DIMENSION OF THE ARRAY PHAS.
C     INTEGER IPRT
C        THE LOGICAL UNIT USED FOR PRINTED OUTPUT.
C     INTEGER ISPCF
C         THE ACTUAL DIMENSION FOR THE SPECTRUM ARRAYS.
C     INTEGER J
C        INDEX VARIABLE.
C     INTEGER LACOV
C        THE LENGTH OF THE VECTOR ACOV.
C     INTEGER LAGMAX
C        THE INDEXING VARIABLE INDICATING THE LAG VALUE OF THE
C        AUTOCOVARIANCE BEING COMPUTED AND THE MAXIMUM LAG TO BE USED,
C        RESPECTIVELY.
C     INTEGER LAGS(4)
C        THE ARRAY USED TO STORE THE LAG WINDOW TRUCCATION
C        POINTS USED FOR EACH SET OF SPECTRUM VALUES.
C     INTEGER LDS, LDSTAK
C        THE LENGTH OF THE VECTOR DSTAK IN COMMON CSTAK.
C     INTEGER LYFFT
C        THE LENGTH OF THE VECTORS YFFT AND ZFFT, RESPECTIVELY..
C     INTEGER NF
C        THE NUMBER OF FREQUENCIES AT WHICH THE SPECTRUM IS
C        TO BE COMPUTED.
C     INTEGER NLPPC(101,2,2)
C        THE NUMBERS OF LAGGED PRODUCT PAIRS USED FOR EACH ACVF.
C     INTEGER NPRT
C        A CODE USED TO SPECIFY THE TYPE OF PLOT.
C        IF NPRT < 0 THE PLOT IS DECIBLES/LINEAR
C        IF NPRT = 0 THE PLOT IS SUPPRESSED.
C        IF NPRT > 0 THE PLOT IS LOG/LINEAR
C     INTEGER NW
C        THE NUMBER OF DIFFERENT LAG WINDOW TRUNCATION POINTS SPECIFIED,
C        AND THEREFORE, THE NUMBER OF PLOTS.
C     INTEGER N
C        THE NUMBER OF OBSERVATIONS IN THE SERIES Y.
C     REAL PHAS(300,2)
C        THE PHASE COMPONENT OF THE SPECTRUM.
C     REAL YFFT1(400), YFFT2(400)
C        THE VECTORS OF THE OBSERVED TIME SERIES TO BE ANALYZED USING
C        THE FFT.
C     REAL YMISS, YMISS1, YMISS2, YMMISS(4)
C        THE USER SUPPLIED CODE WHICH IS USED TO DETERMINE WHETHER OR
C        NOT AN OBSERVATION IN THE SERIES IS MISSING.  IF Y(I) = YMISS,
C        THE VALUE IS ASSUMED MISSING, OTHERWISE IT IS NOT.
C     REAL YM(150,2)
C        THE MULTIVARIATE REPRESENTATION OF THE DATA
C     REAL Y1(150), Y2(150)
C         THE VECTORS CONTAINING THE TIME SERIES FROM JENKINS AND WATTS.
C
      DATA   Y1(  1),  Y1(  2),  Y1(  3),  Y1(  4),  Y1(  5),  Y1(  6)
     +    /-0.88E0, -0.16E0, -1.87E0, -1.12E0,  1.38E0,  2.13E0/
      DATA   Y1(  7),  Y1(  8),  Y1(  9),  Y1( 10),  Y1( 11),  Y1( 12)
     +    / 2.76E0,  0.56E0, -0.69E0, -1.79E0, -3.82E0, -2.38E0/
      DATA   Y1( 13),  Y1( 14),  Y1( 15),  Y1( 16),  Y1( 17),  Y1( 18)
     +    / 1.00E0,  0.70E0, -0.15E0,  0.98E0,  0.11E0, -0.35E0/
      DATA   Y1( 19),  Y1( 20),  Y1( 21),  Y1( 22),  Y1( 23),  Y1( 24)
     +    /-0.73E0,  0.89E0, -1.63E0, -0.44E0, -1.37E0, -1.71E0/
      DATA   Y1( 25),  Y1( 26),  Y1( 27),  Y1( 28),  Y1( 29),  Y1( 30)
     +    /-1.22E0, -2.00E0, -0.22E0,  0.38E0,  1.31E0,  0.71E0/
      DATA   Y1( 31),  Y1( 32),  Y1( 33),  Y1( 34),  Y1( 35),  Y1( 36)
     +    / 0.32E0,  0.48E0, -1.88E0, -0.94E0, -1.54E0, -0.13E0/
      DATA   Y1( 37),  Y1( 38),  Y1( 39),  Y1( 40),  Y1( 41),  Y1( 42)
     +    / 1.02E0,  0.02E0, -0.77E0,  0.11E0, -0.60E0, -0.52E0/
      DATA   Y1( 43),  Y1( 44),  Y1( 45),  Y1( 46),  Y1( 47),  Y1( 48)
     +    /-0.09E0,  1.23E0,  1.46E0,  0.61E0,  0.42E0,  2.16E0/
      DATA   Y1( 49),  Y1( 50),  Y1( 51),  Y1( 52),  Y1( 53),  Y1( 54)
     +    / 3.18E0,  2.10E0,  0.37E0, -0.24E0,  0.57E0, -0.53E0/
      DATA   Y1( 55),  Y1( 56),  Y1( 57),  Y1( 58),  Y1( 59),  Y1( 60)
     +    / 2.44E0,  1.02E0, -0.53E0, -2.49E0, -2.12E0, -1.04E0/
      DATA   Y1( 61),  Y1( 62),  Y1( 63),  Y1( 64),  Y1( 65),  Y1( 66)
     +    /-0.12E0, -1.88E0, -1.50E0,  1.54E0,  3.33E0,  3.08E0/
      DATA   Y1( 67),  Y1( 68),  Y1( 69),  Y1( 70),  Y1( 71),  Y1( 72)
     +    / 1.71E0,  0.79E0,  1.55E0,  0.89E0, -0.89E0, -1.18E0/
      DATA   Y1( 73),  Y1( 74),  Y1( 75),  Y1( 76),  Y1( 77),  Y1( 78)
     +    / 0.89E0,  1.71E0,  3.05E0,  0.15E0, -1.04E0,  0.12E0/
      DATA   Y1( 79),  Y1( 80),  Y1( 81),  Y1( 82),  Y1( 83),  Y1( 84)
     +    / 0.08E0,  0.11E0, -2.62E0, -1.28E0,  1.07E0,  3.20E0/
      DATA   Y1( 85),  Y1( 86),  Y1( 87),  Y1( 88),  Y1( 89),  Y1( 90)
     +    / 1.92E0,  0.53E0, -1.08E0,  0.49E0, -0.58E0,  0.17E0/
      DATA   Y1( 91),  Y1( 92),  Y1( 93),  Y1( 94),  Y1( 95),  Y1( 96)
     +    / 1.15E0, -0.97E0, -1.63E0,  1.14E0, -0.67E0, -0.88E0/
      DATA   Y1( 97),  Y1( 98),  Y1( 99),  Y1(100)
     +    /-0.07E0,  0.24E0,  0.55E0, -2.16E0/
      DATA   Y2(  1),  Y2(  2),  Y2(  3),  Y2(  4),  Y2(  5),  Y2(  6)
     +    / 0.79E0,  1.12E0, -1.10E0, -2.39E0, -1.75E0, -0.82E0/
      DATA   Y2(  7),  Y2(  8),  Y2(  9),  Y2( 10),  Y2( 11),  Y2( 12)
     +    /-0.36E0,  1.27E0,  1.75E0,  2.44E0,  0.36E0, -2.10E0/
      DATA   Y2( 13),  Y2( 14),  Y2( 15),  Y2( 16),  Y2( 17),  Y2( 18)
     +    /-1.93E0, -1.30E0, -1.75E0, -0.34E0,  0.74E0,  0.49E0/
      DATA   Y2( 19),  Y2( 20),  Y2( 21),  Y2( 22),  Y2( 23),  Y2( 24)
     +    / 0.70E0,  0.71E0,  0.09E0,  0.59E0,  1.54E0,  0.14E0/
      DATA   Y2( 25),  Y2( 26),  Y2( 27),  Y2( 28),  Y2( 29),  Y2( 30)
     +    / 0.55E0, -1.40E0, -2.55E0, -1.66E0, -0.43E0,  0.58E0/
      DATA   Y2( 31),  Y2( 32),  Y2( 33),  Y2( 34),  Y2( 35),  Y2( 36)
     +    / 2.18E0, -0.24E0,  0.58E0, -0.18E0, -1.55E0, -0.64E0/
      DATA   Y2( 37),  Y2( 38),  Y2( 39),  Y2( 40),  Y2( 41),  Y2( 42)
     +    /-1.09E0,  0.90E0, -0.66E0, -0.35E0,  0.48E0,  0.50E0/
      DATA   Y2( 43),  Y2( 44),  Y2( 45),  Y2( 46),  Y2( 47),  Y2( 48)
     +    / 0.05E0, -0.68E0,  0.24E0,  0.58E0, -1.26E0, -0.25E0/
      DATA   Y2( 49),  Y2( 50),  Y2( 51),  Y2( 52),  Y2( 53),  Y2( 54)
     +    / 0.25E0,  2.18E0,  2.96E0,  1.56E0, -0.36E0, -0.59E0/
      DATA   Y2( 55),  Y2( 56),  Y2( 57),  Y2( 58),  Y2( 59),  Y2( 60)
     +    /-0.12E0,  3.03E0,  2.11E0,  0.78E0,  0.89E0, -1.45E0/
      DATA   Y2( 61),  Y2( 62),  Y2( 63),  Y2( 64),  Y2( 65),  Y2( 66)
     +    /-0.36E0, -0.37E0, -1.39E0, -4.19E0, -0.73E0, -0.98E0/
      DATA   Y2( 67),  Y2( 68),  Y2( 69),  Y2( 70),  Y2( 71),  Y2( 72)
     +    / 0.36E0,  0.06E0, -1.94E0, -0.08E0,  0.17E0,  1.00E0/
      DATA   Y2( 73),  Y2( 74),  Y2( 75),  Y2( 76),  Y2( 77),  Y2( 78)
     +    /-0.05E0,  0.43E0,  0.15E0,  2.69E0,  0.57E0,  0.29E0/
      DATA   Y2( 79),  Y2( 80),  Y2( 81),  Y2( 82),  Y2( 83),  Y2( 84)
     +    / 1.10E0,  0.48E0, -1.06E0, -2.28E0, -2.03E0, -0.75E0/
      DATA   Y2( 85),  Y2( 86),  Y2( 87),  Y2( 88),  Y2( 89),  Y2( 90)
     +    / 1.00E0,  1.71E0,  0.58E0,  1.97E0,  0.99E0,  1.94E0/
      DATA   Y2( 91),  Y2( 92),  Y2( 93),  Y2( 94),  Y2( 95),  Y2( 96)
     +    / 2.18E0,  3.14E0,  0.60E0,  0.51E0,  1.35E0,  0.56E0/
      DATA   Y2( 97),  Y2( 98),  Y2( 99),  Y2(100)
     +    / 0.11E0,  0.00E0,  2.34E0,  1.88E0/
C
C
      CALL IPRINT(IPRT)
      CALL SETRV(YMMISS, 4, 0.89E0)
C
C     CHECK ERROR HANDLING
C
C        TEST 1  -  MISCELANEOUS ERROR CHECKING
C
      WRITE (IPRT, 2000)
      LAGMAX = -1
      N = -10
      INDEX1 = 0
      INDEX2 = 0
      ICCOV = 0
      JCCOV = 0
      INLPPC = 0
      JNLPPC = 0
      ICSPC2 = -10
      IPHAS = -10
      LACOV = -11
      LYFFT = -11
      NW = -1
      NF = -5
      FMIN = 0.5E0
      FMAX = 0.0E0
      NPRT = -1
      ISPCF = -20
      LDSTAK = 0
      YMISS1 = 0.89E0
      YMISS2 = 0.89E0
C
      WRITE(IPRT, 1001)
      CALL BFS (Y1, Y2, N)
      WRITE (IPRT, 1002) IERR
C
      WRITE(IPRT, 1003)
      CALL BFSS(Y1, Y2, N, NW, LAGS, NF, FMIN, FMAX, NPRT,
     +   CSPC2, ICSPC2, PHAS, IPHAS, FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
      WRITE(IPRT, 1019)
      CALL BFSF (YFFT1, YFFT2, N, LYFFT, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
      WRITE(IPRT, 1020)
      CALL BFSFS(YFFT1, YFFT2, N, LYFFT, LDSTAK, NW, LAGS, NF, FMIN,
     +   FMAX, NPRT, CSPC2, ICSPC2, PHAS, IPHAS, FREQ)
      WRITE (IPRT, 1002) IERR
C
      WRITE(IPRT, 1005)
      CALL BFSM (Y1, YMISS1, Y2, YMISS2, N)
      WRITE (IPRT, 1002) IERR
C
      WRITE(IPRT, 1006)
      CALL BFSMS(Y1, YMISS1, Y2, YMISS2, N, NW, LAGS, NF, FMIN,
     +   FMAX, NPRT, CSPC2, ICSPC2, PHAS, IPHAS, FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
      WRITE (IPRT, 1007)
      CALL BFSV(CCOV, INDEX1, INDEX2, N, LAGMAX, ICCOV, JCCOV)
      WRITE (IPRT, 1002) IERR
C
      WRITE (IPRT, 1008)
      CALL BFSVS (CCOV, INDEX1, INDEX2, N, ICCOV, JCCOV,
     +   NW, LAGS, NF, FMIN, FMAX, NPRT, CSPC2, ICSPC2, PHAS, IPHAS,
     +   FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
      WRITE (IPRT, 1021)
      CALL BFSMV(CCOV, NLPPC, INDEX1, INDEX2, N, LAGMAX, ICCOV, JCCOV,
     +   INLPPC, JNLPPC)
      WRITE (IPRT, 1002) IERR
C
      WRITE (IPRT, 1022)
      CALL BFSMVS (CCOV, NLPPC, INDEX1, INDEX2, N, ICCOV, JCCOV,
     +   INLPPC, JNLPPC, NW, LAGS, NF, FMIN, FMAX, NPRT, CSPC2, ICSPC2,
     +   PHAS, IPHAS, FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
C        TEST 2  -  MISCELANEOUS ERROR CHECKING (CONTINUED)
C
      WRITE (IPRT, 2010)
      N = 100
      LAGMAX = 40
      INDEX1 = 0
      INDEX2 = 0
      ICCOV = 0
      JCCOV = 0
      INLPPC = 0
      JNLPPC = 0
      ICSPC2 = 300
      IPHAS = 300
      LACOV = 101
      LYFFT = -11
      NW = 2
      LAGS(1) = 0
      LAGS(2) = 100
      NF = 202
      FMIN = 0.0E0
      FMAX = 0.5E0
      NPRT = 3
      ISPCF = 101
      LDSTAK = 0
C
      WRITE(IPRT, 1003)
      CALL BFSS(Y1, Y2, N, NW, LAGS, NF, FMIN, FMAX, NPRT,
     +   CSPC2, ICSPC2, PHAS, IPHAS, FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
      WRITE(IPRT, 1019)
      CALL BFSF (YFFT1, YFFT2, N, LYFFT, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
      WRITE(IPRT, 1020)
      CALL BFSFS(YFFT1, YFFT2, N, LYFFT, LDSTAK, NW, LAGS, NF, FMIN,
     +   FMAX, NPRT, CSPC2, ICSPC2, PHAS, IPHAS, FREQ)
      WRITE (IPRT, 1002) IERR
C
      WRITE(IPRT, 1006)
      CALL BFSMS(Y1, YMISS1, Y2, YMISS2, N, NW, LAGS, NF, FMIN,
     +   FMAX, NPRT, CSPC2, ICSPC2, PHAS, IPHAS, FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
      WRITE (IPRT, 1008)
      CALL BFSVS (CCOV, INDEX1, INDEX2, N, ICCOV, JCCOV,
     +   NW, LAGS, NF, FMIN, FMAX, NPRT, CSPC2, ICSPC2, PHAS, IPHAS,
     +   FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
      WRITE (IPRT, 1022)
      CALL BFSMVS (CCOV, NLPPC, INDEX1, INDEX2, N, ICCOV, JCCOV,
     +   INLPPC, JNLPPC, NW, LAGS, NF, FMIN, FMAX, NPRT, CSPC2, ICSPC2,
     +   PHAS, IPHAS, FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
C        TEST 3  -  LDSTAK TOO SMALL
C
      WRITE (IPRT, 2030)
      N = 100
      INDEX1 = 2
      INDEX2 = 1
      ICCOV = 101
      JCCOV = 2
      INLPPC = 101
      JNLPPC = 2
      ICSPC2 = 300
      IPHAS = 300
      LAGMAX = 99
      LACOV = 101
      LYFFT = 400
      NW = 2
      LAGS(1) = 8
      LAGS(2) = 16
      NF = 26
      FMIN = 0.0E0
      FMAX = 0.5E0
      NPRT = 1
      ISPCF = 101
      LDSTAK = 0
C
      WRITE(IPRT, 1003)
      CALL BFSS(Y1, Y2, N, NW, LAGS, NF, FMIN, FMAX, NPRT,
     +   CSPC2, ICSPC2, PHAS, IPHAS, FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
      WRITE(IPRT, 1019)
      CALL BFSF (YFFT1, YFFT2, N, LYFFT, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
      WRITE(IPRT, 1020)
      CALL BFSFS(YFFT1, YFFT2, N, LYFFT, LDSTAK, NW, LAGS, NF, FMIN,
     +   FMAX, NPRT, CSPC2, ICSPC2, PHAS, IPHAS, FREQ)
      WRITE (IPRT, 1002) IERR
C
      WRITE(IPRT, 1006)
      CALL BFSMS(Y1, YMISS1, Y2, YMISS2, N, NW, LAGS, NF, FMIN,
     +   FMAX, NPRT, CSPC2, ICSPC2, PHAS, IPHAS, FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
      WRITE (IPRT, 1008)
      CALL BFSVS (CCOV, INDEX1, INDEX2, N, ICCOV, JCCOV,
     +   NW, LAGS, NF, FMIN, FMAX, NPRT, CSPC2, ICSPC2, PHAS, IPHAS,
     +   FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
      WRITE (IPRT, 1022)
      CALL BFSMVS (CCOV, NLPPC, INDEX1, INDEX2, N, ICCOV, JCCOV,
     +   INLPPC, JNLPPC, NW, LAGS, NF, FMIN, FMAX, NPRT, CSPC2, ICSPC2,
     +   PHAS, IPHAS, FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
C        TEST 4  -  ALL DATA AND COVARIANCES MISSING
C
      WRITE (IPRT, 2040)
      N = 100
      LAGMAX = 99
      ICSPC2 = 300
      IPHAS = 300
      LACOV = 101
      LYFFT = 400
      NW = 2
      LAGS(1) = 8
      LAGS(2) = 16
      NF = 26
      FMIN = 0.0E0
      FMAX = 0.5E0
      NPRT = 1
      ISPCF = 101
      LDSTAK = LDS
      CALL SETRV(YFFT1, N, YMISS1)
      CALL SETRV(YFFT2, N, YMISS2)
      CALL SETRV(CCOV, 404, 0.0E0)
      CALL SETIV(NLPPC, 404, 0)
C
      WRITE(IPRT, 1005)
      CALL BFSM (YFFT1, YMISS1, YFFT2, YMISS2, N)
      WRITE (IPRT, 1002) IERR
C
      WRITE(IPRT, 1006)
      CALL BFSMS(YFFT1, YMISS1, YFFT2, YMISS2, N, NW, LAGS, NF, FMIN,
     +   FMAX, NPRT, CSPC2, ICSPC2, PHAS, IPHAS, FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
      WRITE (IPRT, 1021)
      CALL BFSMV(CCOV, NLPPC, INDEX1, INDEX2, N, LAGMAX, ICCOV, JCCOV,
     +   INLPPC, JNLPPC)
      WRITE (IPRT, 1002) IERR
C
      WRITE (IPRT, 1022)
      CALL BFSMVS (CCOV, NLPPC, INDEX1, INDEX2, N, ICCOV, JCCOV,
     +   INLPPC, JNLPPC, NW, LAGS, NF, FMIN, FMAX, NPRT, CSPC2, ICSPC2,
     +   PHAS, IPHAS, FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
C        TEST 5  -  EVERY OTHER VALUE MISSING
C
      WRITE (IPRT, 2050)
      N = 100
      LAGMAX = 99
      ICSPC2 = 300
      IPHAS = 300
      LACOV = 101
      LYFFT = 400
      NW = 2
      LAGS(1) = 8
      LAGS(2) = 16
      NF = 26
      FMIN = 0.0E0
      FMAX = 0.5E0
      NPRT = 1
      ISPCF = 101
      LDSTAK = LDS
      CALL SETRV(YFFT1, N, YMISS1)
      CALL SETRV(YFFT2, N, YMISS2)
      DO 10 I = 1, N, 2
         YFFT1(I) = Y1(I)
         YFFT2(I) = Y2(I)
   10 CONTINUE
C
      WRITE(IPRT, 1005)
      CALL BFSM (YFFT1, YMISS1, YFFT2, YMISS2, N)
      WRITE (IPRT, 1002) IERR
C
      WRITE(IPRT, 1006)
      CALL BFSMS(YFFT1, YMISS1, YFFT2, YMISS2, N, NW, LAGS, NF, FMIN,
     +   FMAX, NPRT, CSPC2, ICSPC2, PHAS, IPHAS, FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
C     CHECK RESULTS FROM VALID CALL
C
      WRITE(IPRT, 2020)
      YMISS = 1.16E0
      N = 100
      LAGMAX = 99
      ICSPC2 = 300
      IPHAS = 300
      LACOV = 101
      LYFFT = 400
      NW = 2
      LAGS(1) = 8
      LAGS(2) = 16
      NF = 26
      FMIN = 0.0E0
      FMAX = 0.5E0
      NPRT = 1
      ISPCF = 101
      LDSTAK = LDS
C
C     TEST OF BFS
C
      WRITE(IPRT, 1001)
      CALL BFS (Y1, Y2, N)
      WRITE (IPRT, 1002) IERR
C
C     TEST OF BFSS
C
      WRITE(IPRT, 2020)
      WRITE(IPRT, 1003)
      CALL BFSS(Y1, Y2, N, NW, LAGS, NF, FMIN,
     +   FMAX, NPRT, CSPC2, ICSPC2, PHAS, IPHAS, FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
C     PRINT RETURNED VALUES FROM BFSS
C
      WRITE (IPRT, 1004) (FREQ(I), (CSPC2(I,J), PHAS(I,J),J=1,NW),
     +   I=1,NF)
C
C     TEST OF BFSF
C
      WRITE(IPRT, 2020)
      WRITE(IPRT, 1019)
      CALL SCOPY(N, Y1, 1, YFFT1, 1)
      CALL SCOPY(N, Y2, 1, YFFT2, 1)
      CALL BFSF (YFFT1, YFFT2, N, LYFFT, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
C     TEST OF BFSFS
C
      WRITE(IPRT, 2020)
      WRITE(IPRT, 1020)
      CALL SCOPY(N, Y1, 1, YFFT1, 1)
      CALL SCOPY(N, Y2, 1, YFFT2, 1)
      CALL BFSFS(YFFT1, YFFT2, N, LYFFT, LDSTAK, NW, LAGS, NF, FMIN,
     +   FMAX, NPRT, CSPC2, ICSPC2, PHAS, IPHAS, FREQ)
      WRITE (IPRT, 1002) IERR
C
C     PRINT RETURNED VALUES FROM BFSFS
C
      WRITE (IPRT, 1004) (FREQ(I), (CSPC2(I,J), PHAS(I,J),J=1,NW),
     +   I=1,NF)
C
C     TEST OF BFSM
C
      WRITE(IPRT, 2020)
      WRITE(IPRT, 1005)
      CALL BFSM (Y1, YMISS1, Y2, YMISS2, N)
      WRITE (IPRT, 1002) IERR
C
C     TEST OF BFSMS
C
      WRITE(IPRT, 2020)
      WRITE(IPRT, 1006)
      CALL BFSMS(Y1, YMISS1, Y2, YMISS2, N, NW, LAGS, NF, FMIN,
     +   FMAX, NPRT, CSPC2, ICSPC2, PHAS, IPHAS, FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
C     PRINT RETURNED VALUES FROM BFSMS
C
      WRITE (IPRT, 1004) (FREQ(I), (CSPC2(I,J), PHAS(I,J),J=1,NW),
     +   I=1,NF)
C
C     TEST OF BFSV
C
      WRITE(IPRT, 2020)
      CALL CCFS (YM, N, 2, 150, LAGMAX, CCOV, ICCOV, JCCOV, 0,
     +   LDSTAK)
      WRITE (IPRT, 1007)
      CALL BFSV(CCOV, INDEX1, INDEX2, N, LAGMAX, ICCOV, JCCOV)
      WRITE (IPRT, 1002) IERR
C
C     TEST OF BFSVS
C
      WRITE(IPRT, 2020)
      WRITE (IPRT, 1008)
      CALL BFSVS(CCOV, INDEX1, INDEX2, N, ICCOV, JCCOV, NW, LAGS, NF,
     +   FMIN, FMAX, NPRT, CSPC2, ICSPC2, PHAS, IPHAS, FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
C     PRINT RETURNED VALUES FROM BFSVS
C
      WRITE (IPRT, 1004) (FREQ(I), (CSPC2(I,J), PHAS(I,J),J=1,NW),
     +   I=1,NF)
C
C     TEST OF BFSMV
C
      WRITE(IPRT, 2020)
      CALL CCFMS (YM, YMMISS, N, 2, 150, LAGMAX, CCOV, CMISS, ICCOV,
     +  JCCOV, NLPPC, INLPPC, JNLPPC, 0, LDSTAK)
      WRITE (IPRT, 1021)
      CALL BFSMV(CCOV, NLPPC, INDEX1, INDEX2, N, LAGMAX, ICCOV,
     +  JCCOV, INLPPC, JNLPPC)
      WRITE (IPRT, 1002) IERR
C
C     TEST OF BFSMVS
C
      WRITE(IPRT, 2020)
      WRITE (IPRT, 1022)
      CALL BFSMVS(CCOV, NLPPC, INDEX1, INDEX2, N, ICCOV,
     +  JCCOV, INLPPC, JNLPPC, NW, LAGS, NF, FMIN, FMAX, NPRT,
     +  CSPC2, ICSPC2, PHAS, IPHAS, FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
C     PRINT RETURNED VALUES FROM BFSMVS
C
      WRITE (IPRT, 1004) (FREQ(I), (CSPC2(I,J), PHAS(I,J),J=1,NW),
     +   I=1,NF)
C
C     MINIMUM PROBLEM SIZE
C
      YMISS = 1.16E0
      N = 17
      LAGMAX = 1
      ICSPC2 = 1
      IPHAS = 1
      LACOV = 101
      LYFFT = 400
      NW = 1
      LAGS(1) = 1
      LAGS(2) = 16
      NF = 1
      FMIN = 0.0E0
      FMAX = 0.5E0
      NPRT = 1
      ISPCF = 101
      LDSTAK = LDS
C
C     TEST OF BFS
C
      WRITE(IPRT, 2060)
      WRITE(IPRT, 1001)
      CALL BFS(Y1, Y2, N)
      WRITE (IPRT, 1002) IERR
C
C     TEST OF BFSS
C
      WRITE(IPRT, 2060)
      WRITE(IPRT, 1003)
      CALL BFSS(Y1, Y2, N, NW, LAGS, NF, FMIN,
     +   FMAX, NPRT, CSPC2, ICSPC2, PHAS, IPHAS, FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
C     PRINT RETURNED VALUES FROM BFSS
C
      WRITE (IPRT, 1004) (FREQ(I), (CSPC2(I,J), PHAS(I,J),J=1,NW),
     +   I=1,NF)
C
C     CHECK HANDLING OF FMIN AND FMAX
C
      YMISS = 1.16E0
      N = 100
      LAGMAX = 99
      ICSPC2 = 300
      IPHAS = 300
      LACOV = 101
      LYFFT = 400
      NW = 2
      LAGS(1) = 8
      LAGS(2) = 16
      NF = 26
      FMIN = 0.45E0
      FMAX = 0.5E0
      NPRT = 1
      ISPCF = 101
      LDSTAK = LDS
C
C     TEST OF BFSS
C
      WRITE(IPRT, 2070)
      WRITE(IPRT, 1003)
      CALL BFSS(Y1, Y2, N, NW, LAGS, NF, FMIN,
     +   FMAX, NPRT, CSPC2, ICSPC2, PHAS, IPHAS, FREQ, LDSTAK)
      WRITE (IPRT, 1002) IERR
C
C     PRINT RETURNED VALUES FROM BFSS
C
      WRITE (IPRT, 1004) (FREQ(I), (CSPC2(I,J), PHAS(I,J),J=1,NW),
     +   I=1,NF)
C
C     CHECK RESULTS FOR WHITE NOISE SPECTRUM
C
      YMISS = 1.16E0
      CALL NRAND(YFFT1, N, 12343)
      CALL NRAND(YFFT2, N, 34523)
      N = 100
      LAGMAX = 99
      ICSPC2 = 300
      IPHAS = 300
      LACOV = 101
      LYFFT = 400
      NW = 2
      LAGS(1) = 8
      LAGS(2) = 16
      NF = 26
      FMIN = 0.0E0
      FMAX = 0.5E0
      NPRT = 1
      ISPCF = 101
      LDSTAK = LDS
C
C     TEST OF BFSFS
C
      WRITE(IPRT, 2080)
      WRITE(IPRT, 1003)
      CALL BFSFS(YFFT1, YFFT2, N, LYFFT, LDSTAK, NW, LAGS, NF, FMIN,
     +   FMAX, NPRT, CSPC2, ICSPC2, PHAS, IPHAS, FREQ)
      WRITE (IPRT, 1002) IERR
C
C     PRINT RETURNED VALUES FROM BFSS
C
      WRITE (IPRT, 1004) (FREQ(I), (CSPC2(I,J), PHAS(I,J),J=1,NW),
     +   I=1,NF)
C
      RETURN
C
C     FORMAT STATEMENTS
C
 1001 FORMAT (12H TEST OF BFS)
 1002 FORMAT (8H IERR IS, I5/)
 1003 FORMAT (13H TEST OF BFSS)
 1004 FORMAT (5(1X, E15.7))
 1005 FORMAT (13H TEST OF BFSM)
 1006 FORMAT (14H TEST OF BFSMS)
 1007 FORMAT (13H TEST OF BFSV)
 1008 FORMAT (14H TEST OF BFSVS)
 1019 FORMAT (13H TEST OF BFSF)
 1020 FORMAT (14H TEST OF BFSFS)
 1021 FORMAT (14H TEST OF BFSMV)
 1022 FORMAT (15H TEST OF BFSMVS)
 2000 FORMAT (32H1CHECK ERROR HANDLING  -  TEST 1)
 2010 FORMAT (32H1CHECK ERROR HANDLING  -  TEST 2)
 2020 FORMAT (14H1VALID PROBLEM)
 2030 FORMAT (14H1LDS TOO SMALL)
 2040 FORMAT (33H1ALL DATA AND COVARIANCES MISSING)
 2050 FORMAT (31H1EVERY OTHER DATA VALUE MISSING)
 2060 FORMAT (21H1MINIMUM PROBLEM SIZE)
 2070 FORMAT (32H1CHECK HANDLING OF FMIN AND FMAX)
 2080 FORMAT (21H1WHITE NOISE SPECTRUM)
      END
